'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); //  weak


var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _findCacheDir = require('find-cache-dir');

var _findCacheDir2 = _interopRequireDefault(_findCacheDir);

var _package = require('../package.json');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// eslint-disable-line

var flattenPath = function flattenPath(str) {
  return str.replace(_path.sep, '-');
};

var Cache = function () {
  function Cache() {
    _classCallCheck(this, Cache);

    this.dir = (0, _findCacheDir2.default)({ name: _package.name, create: true });
  }

  _createClass(Cache, [{
    key: 'get',
    value: function get(id) {
      try {
        return _fs2.default.readFileSync((0, _path.join)(this.dir, `${flattenPath(id)}.js`), 'utf8');
      } catch (err) {
        return null;
      }
    }
  }, {
    key: 'has',
    value: function has(id) {
      return _fs2.default.existsSync((0, _path.join)(this.dir, `${flattenPath(id)}.js`));
    }
  }, {
    key: 'set',
    value: function set(id, body) {
      return _fs2.default.writeFileSync((0, _path.join)(this.dir, `${flattenPath(id)}.js`), body, 'utf8');
    }
  }]);

  return Cache;
}();

exports.default = Cache;