'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelCore = require('babel-core');

var _entities = require('entities');

var _cache = require('./cache');

var _cache2 = _interopRequireDefault(_cache);

var _gist = require('./gist');

var _gist2 = _interopRequireDefault(_gist);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import blog from 'babel-log'

//  weak
var cache = new _cache2.default();

var getGist = function getGist(id) {
  if (cache.has(id)) {
    return cache.get(id);
  }
  var text = (0, _gist2.default)(id);
  cache.set(id, text);
  return (0, _entities.decodeHTML)(text);
};

exports.default = function (_ref) {
  var t = _ref.types,
      traverse = _ref.traverse,
      template = _ref.template;

  var builder = template(`const NAME = BODY`);

  var importDeclaration = function importDeclaration(path) {
    var _path$get = path.get('source.value'),
        src = _path$get.node;

    var _path$get2 = path.get('specifiers.0.local.name'),
        name = _path$get2.node;

    if (src && src.startsWith('gist:')) {
      var id = src.replace('gist:', '');

      var _transform = (0, _babelCore.transform)(getGist(id)),
          ast = _transform.ast;

      traverse(ast, {
        ExportDefaultDeclaration(gistPath) {
          // export default ...
          var decPath = gistPath.get('declaration');
          var output = builder({ NAME: t.identifier(name), BODY: decPath });
          path.replaceWith(output);
        }
      });
    }
  };

  return {
    name: 'gist',
    visitor: {
      ImportDeclaration: importDeclaration
    }
  };
};